HDU3535AreYouBusy[混合背包 分组背包]

AreYouBusy

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3985    Accepted Submission(s):
1580

Problem Description

Happy New Term!
As having become a junior, xiaoA
recognizes that there is not much time for her to AC problems, because there are
some other things for her to do, which makes her nearly mad.
What‘s more, her
boss tells her that for some sets of duties, she must choose at least one job to
do, but for some sets of things, she can only choose at most one to do, which is
meaningless to the boss. And for others, she can do of her will. We just define
the things that she can choose as "jobs". A job takes time , and gives xiaoA
some points of happiness (which means that she is always willing to do the
jobs).So can you choose the best sets of them to give her the maximum points of
happiness and also to be a good junior(which means that she should follow the
boss‘s advice)?

Input

There are several test cases, each test case begins
with two integers n and T (0<=n,T<=100) , n sets of jobs for you to choose
and T minutes for her to do them. Follows are n sets of description, each of
which starts with two integers m and s (0<m<=100), there are m jobs in
this set , and the set type is s, (0 stands for the sets that should choose at
least 1 job to do, 1 for the sets that should choose at most 1 , and 2 for the
one you can choose freely).then m pairs of integers ci,gi follows
(0<=ci,gi<=100), means the ith job cost ci minutes to finish and gi points
of happiness can be gained by finishing it. One job can be done only once.

Output

One line for each test case contains the maximum points
of happiness we can choose from all jobs .if she can’t finish what her boss
want, just output -1 .

Sample Input

3 3
2 1
2 5
3 8
2 0
1 0
2 1
3 2
4 3
2 1
1 1

3 4
2 1
2 5
3 8
2 0
1 1
2 8
3 2
4 4
2 1
1 1

1 1
1 0
2 1

5 3
2 0
1 0
2 1
2 0
2 2
1 1
2 0
3 2
2 1
2 1
1 5
2 8
3 2
3 8
4 9
5 10

Sample Output

5
13
-1
-1

Author

hphp

Source

2010
ACM-ICPC Multi-University Training Contest(10)——Host by HEU


题意:n组,每组m个物品,有三种类型:至少选一个,至多选一个,随便选


d[i][j]表示前i组体积j的最大值

至少选一个:d[i][j]=-INF,保证了至少一个

      d[i][j]=max(d[i][j],max(d[i][j-v[x]]+w[x],d[i-1][j-v[x]]+w[x])) 因为可以选多个 【WARN:不能分成两次max,因为保证至少选一个-INF】

至多选一个:d[i][j]=d[i-1][j],d[i][j]=max(d[i][j],d[i-1][j-v[x]]+w[x]) 可以不选,普通分组背包

随便:d[i][j]=d[i-1][j],d[i][j]=max(d[i][j],d[i][j-v[x]]+w[x]); 可以不选,也可以选多个

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
using namespace std;
const int N=105,INF=1e9;
int read(){
    char c=getchar();int x=0,f=1;
    while(c<‘0‘||c>‘9‘){if(c==‘-‘)f=-1; c=getchar();}
    while(c>=‘0‘&&c<=‘9‘){x=x*10+c-‘0‘; c=getchar();}
    return x*f;
}
int n,t,m,s,v[N],w[N];
int d[N][N];
int main(){
    while(cin>>n>>t){
        memset(d,0,sizeof(d));
        for(int i=1;i<=n;i++){
            m=read();s=read();
            for(int x=1;x<=m;x++){
                v[x]=read();w[x]=read();
            }
            if(s==0){
                for(int j=0;j<=t;j++) d[i][j]=-INF;
                for(int x=1;x<=m;x++)
                    for(int j=t;j>=v[x];j--)
                        d[i][j]=max(d[i][j],max(d[i][j-v[x]]+w[x],d[i-1][j-v[x]]+w[x]));
            }
            else if(s==1){
                for(int j=0;j<=t;j++) d[i][j]=d[i-1][j];
                for(int x=1;x<=m;x++)
                    for(int j=t;j>=v[x];j--)
                        d[i][j]=max(d[i][j],d[i-1][j-v[x]]+w[x]);
            }
            else if(s==2){
                for(int j=0;j<=t;j++) d[i][j]=d[i-1][j];
                for(int x=1;x<=m;x++)
                    for(int j=t;j>=v[x];j--)
                        d[i][j]=max(d[i][j],d[i][j-v[x]]+w[x]);
            }
        }
        printf("%d\n",max(d[n][t],-1));
    }
}
时间: 2025-01-16 03:41:50

HDU3535AreYouBusy[混合背包 分组背包]的相关文章

LuoGu1064-金明的预算方案(依赖背包 || 分组背包)

题目描述 金明今天很开心,家里购置的新房就要领钥匙了,新房里有一间金明自己专用的很宽敞的房间.更让他高兴的是,妈妈昨天对他说:“你的房间需要购买哪些物品,怎么布置,你说了算,只要不超过N元钱就行”.今天一早,金明就开始做预算了,他把想买的物品分为两类:主件与附件,附件是从属于某个主件的,下表就是一些主件与附件的例子: 主件 附件 电脑 打印机,扫描仪 书柜 图书 书桌 台灯,文具 工作椅 无 如果要买归类为附件的物品,必须先买该附件所属的主件.每个主件可以有0个.1个或2个附件.附件不再有从属于

hdu3535---AreYouBusy(混合分组背包,有坑点)

混合的分组背包,如果任意取,就是01背包 如果至多取一个,就是普通的分组背包 如果至少一个,就要考虑第一次和非第一次拿,注意由于体积可以为0,所以先得考虑非第一次拿的,不然某组的同一个物品会被计算2次 /************************************************************************* > File Name: hdu3535.cpp > Author: ALex > Mail: [email protected] >

【背包问题】0-1背包、完全背包、多重背包、混合三种背包、二位费用背包、分组背包

一.0-1背包问题 输入:第一行物品的个数n,第二行背包的质量m,随后n行每行给出每个物品的重量和价值,每种物品只有一个. 输出:背包可以达到的最大价值 样例输入: 5 10 1 5 2 4 3 3 4 2 5 1 样例输出: 14 动态规划的过程中需要逆序,因为如果不是逆序那么 当i=0的时候 f[0]=0; f[1]=max(f[1],f[1-w[0]]+v[0])=5; f[2]=max(f[2],f[2-w[0]]+v[0])=10; f[3]=max(f[3],f[3-w[0]]+v[

ZOJ 3164 Cookie Choice 分组背包 混合背包

http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=3181 题意: 就是混合背包加分组背包,有的物品是01背包,有的是多重背包,有的是完全背包,同时物品还有不超过8组的分组,如果在同一组则最多只能选一种.问能不能恰好地用掉D的容量,并且使所获价值最大. 分析: 开始的想法是多开一个下标,先把没有分组的做了,在0的下标,然后分组分别在组号的下标里按顺序处理,是什么背包就用什么做法,不过一直WA,对拍小数据大数据都没啥问题(可能随机

VijosP1250:分组背包

背景 Wind设计了很多机器人.但是它们都认为自己是最强的,于是,一场比赛开始了~ 描述 机器人们都想知道谁是最勇敢的,于是它们比赛搬运一些物品. 它们到了一个仓库,里面有n个物品,每个物品都有一个价值Pi和重量Wi,但是有些物品放在一起会爆炸,并且爆炸具有传递性.(a和b会爆炸.b和c会爆炸则a和c会爆炸)机器人们可不想因此损失自己好不容易从Wind那里敲诈来的装备,于是它们想知道在能力范围内,它们最多可以拿多少价值的物品. 你能帮助它们吗? 格式 输入格式 每组测试数据第1行为n,Wmax,

HDU-1011 Starship Troopers (树形DP+分组背包)

题目大意:给一棵有根带点权树,并且给出容量.求在不超过容量下的最大权值.前提是选完父节点才能选子节点. 题目分析:树上的分组背包. ps:特判m为0时的情况. 代码如下: # include<iostream> # include<cstdio> # include<vector> # include<cstring> # include<algorithm> using namespace std; const int N=105; const

HDU 4003 Find Metal Mineral (树形DP,树形分组背包,经典)

题意:给定一棵树图,n个节点,有边权,要派k<11个机器人从节点s出发,遍历所有的点,每当1只机器人经过1条边时就会花费该边的边权,边是可重复走的.问遍历完所有点的最小花费? 思路: 非常经典,首先需要知道一点,才能往下推理.就是“如果在t点派c个机器人往孩子u,那么最多只有1个机器人能走会回来到t,否则花费总是不划算的”. 稍微证明一下: (1)假设派1个机器人往u,逛一圈回到u的父亲t,花费v= 子树u的边权和*2 + e(t,u)*2.若机器人不要了,那花费肯定比v还要少. (2)假设派2

HDU 1712 ACboy needs your help-dp-(分组背包模型)

题意:n门课程用m天来学习,每门课用不同的天数来学习会有不同的学分,求能得到的最大的学分 分析:第一次接触分组背包.分组背包的模型就是不同的物品有不同的花费和价值,求在规定花费内能得到的最大的价值,这前面跟以前的背包最大的不同是物品分为几组,每组内的物品最多只能选一种:dp[i][j]表示前i组花费j能得到的最大的价值,不过实际在做的时候用一维数组就可以了 公式: for 组i for 花费j (从大到小) for 组内物品k if(j>=c[k]) dp[j]=max(dp[j],dp[j-c

hdu 1712 分组背包

背景:1Y,01背包多加了一个挑选循环而已. 分组背包的典型描述:对于很多背包,把它分为k个组,每个组内的组员是相互冲突的,所以只能选择一个. 我的代码: #include<cstdio> #include<iostream> #include<cstring> using namespace std; int main(void){ int n,m; while(scanf("%d%d",&n,&m),n*n+m*m){ int c